"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.FileDownloadLink = void 0;
const react_1 = __importStar(require("react"));
const utils_1 = require("../utils");
const FileDownloadLink = ({ fileType, encoding = "utf-8", filename = "data", data, onClick, setsDataAsyncInOnClick, children, }) => {
    const [downloadUrl, setDownloadUrl] = (0, react_1.useState)();
    const [downloadOnDataChange, setDownloadOnDataChange] = (0, react_1.useState)(false);
    const downloadLink = (0, react_1.useRef)(null);
    (0, react_1.useEffect)(() => {
        if (data) {
            setDownloadUrl((0, utils_1.createDownloadUrl)((0, utils_1.dataToString)(data.columnNames, data.rows, fileType), fileType, encoding));
        }
    }, [data, fileType, encoding]);
    (0, react_1.useEffect)(() => {
        var _a;
        if (downloadOnDataChange) {
            (_a = downloadLink.current) === null || _a === void 0 ? void 0 : _a.click();
            setDownloadOnDataChange(false);
        }
    }, [downloadUrl]);
    const handleClick = (e) => __awaiter(void 0, void 0, void 0, function* () {
        /* The data url is already set, so this click is only to trigger the download */
        if (downloadOnDataChange) {
            return;
        }
        if (setsDataAsyncInOnClick) {
            e.preventDefault();
            setDownloadOnDataChange(true);
        }
        if (onClick) {
            yield onClick(e);
        }
    });
    const filenameWithExtension = filename.endsWith(`.${fileType.toLowerCase()}`)
        ? filename
        : `${filename}.${fileType.toLowerCase()}`;
    return (react_1.default.createElement("a", { href: downloadUrl, download: filenameWithExtension, onClick: handleClick, ref: downloadLink }, children));
};
exports.FileDownloadLink = FileDownloadLink;
exports.default = exports.FileDownloadLink;
